"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InteractionEvaluationPlan = void 0;
const moment = require("moment");
class InteractionEvaluationPlan {
    constructor(interaction) {
        this.vcc = null;
        this.evaluationPlanId = null;
        this.interactionType = null;
        this.formattedEndDate = null;
        this.campaignId = null;
        this.interactionId = null;
        this.interactionSection = null;
        this.interactionPart = null;
        this.agentId = null;
        this.agentName = null;
        this.interactionMessages = null;
        this.interactionStartDate = null;
        this.interactionEndDate = null;
        this.interactionDuration = null;
        this.interactionOrigin = null;
        this.interactionFormat = null;
        this.managementResult = null;
        this.exportedContent = null;
        this.relativePath = null;
        this.relativeFileName = null;
        this.fileName = null;
        this.contactId = null;
        this.contactName = null;
        this.contactAddress = null;
        this.needI6Update = null;
        this.interactionRawChar = null;
        this.ender = null;
        this.ticket = null;
        if (interaction) {
            this.vcc = interaction.vcc;
            this.interactionType = interaction.channel;
            this.campaignId = interaction.campaign;
            this.interactionId = interaction.id;
            this.interactionStartDate = moment.utc(interaction.startDate).toDate();
            this.interactionEndDate = moment.utc(interaction.endDate).toDate();
            this.interactionDuration = interaction.attentionTime || interaction.durationTime || null;
            this.relativePath = interaction.relativePath;
            this.relativeFileName = interaction.relativeFileName;
            this.contactName = interaction.contactName;
            this.contactAddress = interaction.contactAddress;
            this.needI6Update = interaction.needI6Update || false;
            this.ender = interaction.ender;
            this.ticket = interaction.ticket;
            if (this.interactionType === 'CALL') {
                this.interactionSection = interaction.section;
                this.interactionPart = interaction.part;
                this.agentId = interaction.agent;
                this.agentName = interaction.agentName;
                this.interactionOrigin = interaction.type;
                if (interaction.description) {
                    this.managementResult = '/';
                    if (interaction.category1)
                        this.managementResult += interaction.category1 + '/';
                    if (interaction.category2)
                        this.managementResult += interaction.category2 + '/';
                    if (interaction.category3)
                        this.managementResult += interaction.category3 + '/';
                    this.managementResult += interaction.description;
                    this.managementResult = this.managementResult.split('//').join('/');
                }
                this.contactId = interaction.number || interaction.contactId || interaction.contactName;
            }
            else {
                this.formattedEndDate = interaction.folder;
                this.agentId = interaction.firstTakedAgent || interaction.lastTakedAgent || null;
                this.agentName = interaction.firstTakedAgentName || interaction.lastTakedAgentName || null;
                this.interactionMessages = interaction.totalMessages;
                this.interactionOrigin = interaction.initiative;
                this.managementResult = interaction.dispositionTreePath || interaction.dispositionCode || null;
                this.contactId = interaction.contactId || interaction.contactName;
                this.interactionRawChar = interaction.rawChar;
                if (this.agentId?.includes('@'))
                    this.agentId = this.agentId.split('@')[0];
                if (this.campaignId?.includes('@'))
                    this.campaignId = this.campaignId.split('@')[0];
            }
        }
    }
}
exports.InteractionEvaluationPlan = InteractionEvaluationPlan;
