"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CSVInteraction = exports.InteractionCognitiveResult = exports.InteractionQueryResult = exports.AsyncInteractionView = exports.AsyncInteraction = exports.ResultsCodesFilters = exports.InteractionView = exports.InteractionSelect = exports.InteractionSearch = exports.LevelTag = exports.Level = exports.InteractionTag = exports.InteractionData = exports.MultimediaPart = exports.MultimediaPartGroup = exports.AuditorInboxInteraction = exports.Interaction = void 0;
const moment = require("moment");
class Interaction {
    constructor(id, idCampaign, idAgent, dateIni, dateFin, interactionTime, interactionType, dispositionCode, address, origin, evaluated = false, descriptionCampaign = null, descriptionAgent = null, idEvaluationPlan = null, descriptionEvaluationPlan = null, dateFinEvaluationPlan = null, qualification = null, descriptionAuditor = null, idAuditorEvaluationPlan = null, textAvailable = false, interactionText = null, completed = null) {
        this.id = id;
        this.idCampaign = idCampaign;
        this.idAgent = idAgent;
        this.dateIni = dateIni;
        this.dateFin = dateFin;
        this.interactionTime = interactionTime;
        this.interactionType = interactionType;
        this.dispositionCode = dispositionCode;
        this.address = address;
        this.origin = origin;
        this.evaluated = evaluated;
        this.descriptionCampaign = descriptionCampaign;
        this.descriptionAgent = descriptionAgent;
        this.idEvaluationPlan = idEvaluationPlan;
        this.descriptionEvaluationPlan = descriptionEvaluationPlan;
        this.dateFinEvaluationPlan = dateFinEvaluationPlan;
        this.qualification = qualification;
        this.descriptionAuditor = descriptionAuditor;
        this.idAuditorEvaluationPlan = idAuditorEvaluationPlan;
        this.textAvailable = textAvailable;
        this.interactionText = interactionText;
        this.completed = completed;
        this.selected = false;
        this.interactionPartGroups = [];
        this.hasVideo = false;
        this.number = null;
        this.agentName = '';
        this.vcc = '';
    }
}
exports.Interaction = Interaction;
class AuditorInboxInteraction {
    constructor() {
        this.address = null;
        this.agentName = null;
        this.auditorName = null;
        this.dateFin = null;
        this.descriptionAgent = null;
        this.descriptionCampaign = null;
        this.descriptionEvaluationPlan = null;
        this.dispositionCode = null;
        this.idAuditor = null;
        this.idEvaluationPlan = null;
        this.interactionTime = null;
        this.interactionType = null;
        this.id = null;
        this.origin = null;
        this.status = false;
        this.evaluationPlanModality = null;
        this.evaluationPlanEvaluationMode = null;
        this.isEvaluationBeingEvaluated = false;
        this.isInteractionBeingEvaluated = false;
    }
}
exports.AuditorInboxInteraction = AuditorInboxInteraction;
class MultimediaPartGroup {
    constructor(agentId, parts = []) {
        this.agentId = agentId;
        this.parts = parts;
    }
}
exports.MultimediaPartGroup = MultimediaPartGroup;
class MultimediaPart {
    constructor(section, part, partURL, agentId, format) {
        this.section = section;
        this.part = part;
        this.partURL = partURL;
        this.agentId = agentId;
        this.format = format;
    }
}
exports.MultimediaPart = MultimediaPart;
class InteractionData {
    constructor() {
        this.vcc = null;
        this.id = null;
        this.startDate = null;
        this.endDate = null;
        this.campaignId = null;
        this.campaignDescription = null;
        this.agentId = null;
        this.agentDescription = null;
        this.type = null;
        this.duration = null;
        this.contactId = null;
        this.contactName = null;
        this.origin = null;
    }
}
exports.InteractionData = InteractionData;
class InteractionTag {
    constructor(idInteraction, idTag, descriptionTag) {
        this.idInteraction = idInteraction;
        this.idTag = idTag;
        this.descriptionTag = descriptionTag;
        this.selected = false;
    }
}
exports.InteractionTag = InteractionTag;
class Level {
    constructor(id, idInteraction, urlStreaming) {
        this.id = id;
        this.idInteraction = idInteraction;
        this.urlStreaming = urlStreaming;
        this.selected = false;
    }
}
exports.Level = Level;
class LevelTag {
    constructor(idLevel, idInteraction, idTag, descriptionTag) {
        this.idLevel = idLevel;
        this.idInteraction = idInteraction;
        this.idTag = idTag;
        this.descriptionTag = descriptionTag;
        this.selected = false;
    }
}
exports.LevelTag = LevelTag;
class InteractionSearch {
    constructor() {
        this.searchType = null;
        this.storageId = null;
        this.evaluationStatus = [];
        this.interactionIds = [];
        this.withSectionPart = false;
        this.efectivityMode = false;
    }
}
exports.InteractionSearch = InteractionSearch;
class InteractionSelect {
}
exports.InteractionSelect = InteractionSelect;
class InteractionView {
    constructor() { }
}
exports.InteractionView = InteractionView;
class ResultsCodesFilters {
}
exports.ResultsCodesFilters = ResultsCodesFilters;
class AsyncInteraction {
    constructor() {
        this.firstTakedAgentName = null;
        this.lastTakedAgentName = null;
        this.category1 = this.GetCategory(0);
        this.category2 = this.GetCategory(1);
        this.category3 = this.GetCategory(2);
        this.category4 = this.GetCategory(3);
        this.category5 = this.GetCategory(4);
        this.relativePath = null;
        this.fileName = null;
        this.relativeFileName = null;
        this.needI6Update = true;
    }
    GetCategory(index) {
        let category = null;
        if (this.dispositionTreePath) {
            let categoriesArr = this.dispositionTreePath.split('/');
            if (categoriesArr.length > index)
                category = categoriesArr[index];
        }
        return category;
    }
}
exports.AsyncInteraction = AsyncInteraction;
class AsyncInteractionView {
    constructor() { }
}
exports.AsyncInteractionView = AsyncInteractionView;
class InteractionQueryResult {
    constructor() {
        this.interactionId = null;
        this.section = null;
        this.part = null;
        this.interactionType = null;
        this.transactionType = null;
        this.transactionId = null;
        this.transactionName = null;
        this.analysisType = null;
        this.queryId = null;
        this.queryName = null;
        this.queryValue = null;
        this.queryData = null;
        this.matches = null;
        this.details = null;
    }
}
exports.InteractionQueryResult = InteractionQueryResult;
class InteractionCognitiveResult {
    constructor() {
        this.interactionId = null;
        this.section = null;
        this.part = null;
        this.interactionType = null;
        this.vcc = null;
        this.processResultId = null;
        this.typeProcessResultId = null;
    }
}
exports.InteractionCognitiveResult = InteractionCognitiveResult;
class CSVInteraction {
    constructor(data) {
        this.id = null;
        this.channel = null;
        this.number = null;
        this.startDate = null;
        this.endDate = null;
        this.durationTime = null;
        this.agent = null;
        this.agentName = null;
        this.campaign = null;
        this.gender = null;
        this.silenceTime = null;
        this.category1 = null;
        this.category2 = null;
        this.category3 = null;
        this.description = null;
        this.direction = null;
        this.dispositionCode = null;
        this.relativePath = null;
        this.relativeFileName = null;
        this.rawChar = null;
        this.setRawData(data);
    }
    setRawData(data) {
        this.id = data.ID;
        this.channel = data.Channel;
        this.number = data.Number;
        this.startDate = moment.utc(data.StartDate).toDate();
        this.endDate = moment.utc(data.EndDate).toDate();
        this.durationTime = data.DurationTime;
        this.agent = data.Agent;
        this.agentName = data.AgentName;
        this.campaign = data.Campaign;
        this.gender = data.Gender;
        this.silenceTime = data.SilenceTime;
        this.category1 = data.Category1;
        this.category2 = data.Category2;
        this.category3 = data.Category3;
        this.description = data.Description;
        this.direction = data.Direction;
        this.dispositionCode = data.DispositionCode;
        this.relativePath = data.RelativePath;
        this.relativeFileName = data.RelativeFileName;
        this.rawChar = data.RawChar;
    }
    exportToCallInteraction() {
        let interaction = {};
        interaction.id = this.id;
        interaction.section = '0';
        interaction.part = '0';
        interaction.channel = 'CALL',
            interaction.number = this.number;
        interaction.gender = this.gender;
        interaction.silenceTime = this.silenceTime?.toString() || null;
        interaction.durationTime = this.durationTime?.toString() || null;
        interaction.category1 = this.category1;
        interaction.category2 = this.category2;
        interaction.category3 = this.category3;
        interaction.description = this.description;
        interaction.campaign = this.campaign;
        interaction.agent = this.agent;
        interaction.agentName = this.agentName;
        interaction.type = this.direction === 'E' ? 'IN' : 'OUT';
        interaction.init = null;
        interaction.startDate = this.startDate;
        interaction.endDate = this.endDate;
        interaction.dispositionCode = this.dispositionCode;
        interaction.relativePath = this.relativePath;
        interaction.relativeFileName = this.relativeFileName;
        interaction.contactId = null;
        interaction.contactName = null;
        interaction.contactAddress = null;
        interaction.needI6Update = false;
        if (interaction.relativePath?.length) {
            let relativePathArray = interaction.relativePath.split('/');
            if (interaction.relativePath.match(/\.(mp3|wav|ogg)$/))
                interaction.relativeFileName = relativePathArray.pop();
            interaction.relativePath = relativePathArray.filter(rpa => rpa.length).join('/');
            if (!interaction.relativePath.startsWith('/'))
                interaction.relativePath = '/' + interaction.relativePath;
            if (interaction.relativePath.endsWith('/'))
                interaction.relativePath = interaction.relativePath.replace(/\/$/, '');
        }
        return interaction;
    }
    exportToTextInteraction() {
        let interaction = new AsyncInteraction();
        interaction.id = this.id;
        interaction.folder = moment(this.endDate).format('YYYY-MM-DD');
        interaction.channel = this.channel;
        interaction.campaign = this.campaign;
        interaction.startDate = this.startDate;
        interaction.endDate = this.endDate;
        interaction.initiative = this.direction === 'E' ? 'IN' : 'OUT';
        interaction.contactAddress = this.number;
        interaction.lastTakedAgent = this.agent;
        interaction.lastTakedAgentName = this.agentName;
        interaction.durationTime = this.durationTime.toString();
        interaction.attentionTime = this.durationTime.toString();
        interaction.dispositionCode = this.dispositionCode || null;
        interaction.relativePath = this.relativePath;
        interaction.rawChar = this.rawChar;
        interaction.needI6Update = false;
        if (interaction.relativePath?.length) {
            let relativePathArray = interaction.relativePath.split('/');
            if (interaction.relativePath.match(/\.(json)$/))
                interaction.relativeFileName = relativePathArray.pop();
            interaction.relativePath = relativePathArray.filter(rpa => rpa.length).join('/');
            if (!interaction.relativePath.startsWith('/'))
                interaction.relativePath = '/' + interaction.relativePath;
            if (interaction.relativePath.endsWith('/'))
                interaction.relativePath = interaction.relativePath.replace(/\/$/, '');
        }
        return interaction;
    }
}
exports.CSVInteraction = CSVInteraction;
